/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+,78K0S/KU1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.70 [7 Dec. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "int.h"
#include "port.h"
#include "timer.h"
#include "watchdogtimer.h"
#include "lvi.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
unsigned char	set_count;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw5_key;
unsigned char	sw5_rep;
unsigned char	sw6_key;
unsigned char	sw6_rep;
unsigned char	sw7_key;
unsigned char	sw7_rep;
unsigned char	sw8_key;
unsigned char	sw8_rep;

unsigned char	sw_flg;
unsigned char	move_flg;

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
void	head_out(void)
{
	set_count=8;
	TM00_Start();
	TM80_Start();
	while(set_count>0){}
	TM00_Stop();
	TM80_Stop();
}
void	data1_out(void)
{
	set_count=1;
	TM80_Start();
	while(set_count>0){}
	TM80_Stop();
	set_count=2;
	TM00_Start();
	TM80_Start();
	while(set_count>0){}
	TM00_Stop();
	TM80_Stop();
}
void	data0_out(void)
{
	set_count=1;
	TM80_Start();
	while(set_count>0){}
	TM80_Stop();
	set_count=1;
	TM00_Start();
	TM80_Start();
	while(set_count>0){}
	TM00_Stop();
	TM80_Stop();
}
void	end1_out(void)
{
	set_count=27;
	TM80_Start();
	while(set_count>0){}
	TM80_Stop();
}
void	end2_out(void)
{
	set_count=127;
	TM80_Start();
	while(set_count>0){}
	TM80_Stop();
}
void	data5_out(unsigned char data)
{
unsigned char d,i;

	for(i=0;i<5;i++){
		d=data & 0x01;
		if(d==0x01){data1_out();}
		else{data0_out();}
		data=data>>1;
	}
}
void	rem_out(unsigned char data)
{
unsigned char	out_data;

	out_data=0x1e;
	switch(data){
		case 0:out_data=0x10;break;
		case 1:out_data=0x08;break;
		case 2:out_data=0x02;break;
		case 3:out_data=0x04;break;
		case 4:out_data=0x12;break;
		case 5:out_data=0x14;break;
		case 6:out_data=0x0a;break;
		case 7:out_data=0x0c;break;
		case 8:out_data=0x1e;break;
	}
	if(sw_flg==0){out_data=out_data|0x01;}
	
	head_out();
	data5_out(out_data);
	end1_out();
	head_out();
	data5_out(out_data);
	end1_out();
	end2_out();
}
void 	main( void )
{

	P2.1=1;
	move_flg=0;

	/* TODO. add user code */
	while(1){

	/* key scan 1 */
		if ((P4.0==0)&(P4.2==1)&(P4.3==1)){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(P4.2==1)&(P4.3==1)){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/
		if ((P4.2==0)&(P4.0==1)&(P4.1==1)){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
		}
		/*------------------*/
		if ((P4.3==0)&(P4.0==1)&(P4.1==1)){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
		}
		/*------------------*/
		if ((P4.0==0)&(P4.2==0)){
				sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
		}
		/*------------------*/
		if ((P4.0==0)&(P4.3==0)){
				sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(P4.2==0)){
				sw7_key=0;
		}
		else{
			sw7_key=1;
			sw7_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(P4.3==0)){
				sw8_key=0;
		}
		else{
			sw8_key=1;
			sw8_rep=0;
		}
		/*------------------*/

	wait_time(100);

	/* key scan 2 */
		if ((P4.0==0)&(P4.2==1)&(P4.3==1)&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(P4.2==1)&(P4.3==1)&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/
		if ((P4.2==0)&(P4.0==1)&(P4.1==1)&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
		}
		/*------------------*/
		if ((P4.3==0)&(P4.0==1)&(P4.1==1)&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
		}
		/*------------------*/
		if ((P4.0==0)&(P4.2==0)&(sw5_key==0)){
			sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
		}
		/*------------------*/
		if ((P4.0==0)&(P4.3==0)&(sw6_key==0)){
			sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(P4.2==0)&(sw7_key==0)){
			sw7_key=0;
		}
		else{
			sw7_key=1;
			sw7_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(P4.3==0)&(sw8_key==0)){
			sw8_key=0;
		}
		else{
			sw8_key=1;
			sw8_rep=0;
		}
		/*------------------*/


		
	/* flg scan */
	
		P2.1=0;
		wait_time(10);
		if(P2.0==1){
			sw_flg=1;
		}
		else{
			sw_flg=0;
		}
		P2.1=1;

	/* Stop mode check */
		if((sw1_key==1)&(sw2_key==1)&(sw3_key==1)&(sw4_key==1)&(sw5_key==1)&(sw6_key==1)&(sw7_key==1)&(sw8_key==1)){
			if(move_flg==1){
				rem_out(8);
				move_flg=0;
			}
			
			STOP();
		}

	/* key action */
	
		if(sw1_key==0){
			rem_out(0);move_flg=1;
		}
		if(sw2_key==0){
			rem_out(1);move_flg=1;
		}
		if(sw3_key==0){
			rem_out(2);move_flg=1;
		}
		if(sw4_key==0){
			rem_out(3);move_flg=1;
		}
		if(sw5_key==0){
			rem_out(4);move_flg=1;
		}
		if(sw6_key==0){
			rem_out(5);move_flg=1;
		}
		if(sw7_key==0){
			rem_out(6);move_flg=1;
		}
		if(sw8_key==0){
			rem_out(7);move_flg=1;
		}

		;
	}
}

