/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+,78K0S/KU1+ 8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation  assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	timer.h
**  Abstract :	This file implements device driver for the timer module.
**  APIlib:	NEC78K0SKX1+.lib V1.70 [7 Dec. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*****************************************************************************
*/

#ifndef _MDTIMER_
#define _MDTIMER_
#define	TM_TM00_CLOCK	0x0
#define	TM_TM00_INTERVALVALUE	0x68
#define	TM_TM00_SQUAREWIDTH	0x68
#define	TM_TM00_PPGCYCLE	0x68
#define	TM_TM00_PPGWIDTH	0x00
#define	TM_TM00_ONESHOTCYCLE	0x68
#define	TM_TM00_ONEPULSEDELAY	0x00
#define	TM_TM80_CLOCK	0x0
#define	TM_TM80_INTERVALVALUE	0x50
#define	TM_TMH1_CLOCK	0x4
#define	TM_TMH1_INTERVALVALUE	0x26
#define	TM_TMH1_SQUAREWIDTH	0x26
#define	TM_TMH1_PWMCYCLE	0x26
#define	TM_TMH1_PWMDELAY	0x00


/* timer00, 80, H1 configurator initiation */
void TM00_Init( void );
void TM80_Init( void );
void TMH1_Init( void );

/* timer start */
void TM00_Start( void );
void TM80_Start( void );
void TMH1_Start( void );

/* timer stop */
void TM00_Stop( void );
void TM80_Stop( void );
void TMH1_Stop( void );
MD_STATUS TM00_ChangeTimerCondition( USHORT* array_reg, USHORT array_num );
MD_STATUS TM80_ChangeTimerCondition( UCHAR value );
MD_STATUS TMH1_ChangeTimerCondition( UCHAR* array_reg, UCHAR array_num );
__interrupt void MD_INTTM80( );
#endif		/* _MDTIMER_*/
